#ifndef MBRICKELECONSTIDPARSERFACTORYIMPL_H_
#define MBRICKELECONSTIDPARSERFACTORYIMPL_H_

#include <mobjectmanager.h>
#include <mbrickeleconstidparserimpl.h>
#include <org.sipesc.fems.global.mmaterialsglobal.h>
#include <org.sipesc.fems.hexaelement.mbrickeleconstidparserfactory.h>
using namespace org::sipesc::fems::global;
using namespace org::sipesc::fems::hexaelement;

class MBrickEleConstiDParserFactoryImpl: public MBrickEleConstiDParserFactoryInterface
  {
  public:
    /**
     * 析构函数. 仅为类继承关系而设置.
     */
    virtual ~MBrickEleConstiDParserFactoryImpl()
      {
      }

  public:
    QList<QVariant> getTypes() const
      {
      MObjectManager objManager = MObjectManager::getManager();
      MMaterialsGlobal global = objManager.getObject(
          "org.sipesc.fems.global.materialsglobal");
      QList<QVariant> list;
      list << global.getValue(MMaterialsGlobal::SolidIsoType);
      return list;
      }

    QString getDescription() const
      {
      return "factory for MBrickEleConstiDParser";
      }

    QString getIcon() const
      {
      return QString();
      }
    /*
     * 返回优先级
     */
    uint getPriority(const QVariant& key) const
      {
      return 10;
      }
    /**
     * create task object
     *
     * @return return a valid MExtensionWrapper object
     */
    MExtension createExtension(const QVariant& key) const
      {
      MBrickEleConstiDParserImpl* p = new MBrickEleConstiDParserImpl;
      return MBrickEleConstiDParser(p);
      }
  };

#endif /* MBRICKELECONSTIDPARSERFACTORYIMPL_H_ */
