#ifndef MBRICKELESTIFFBUILDERIMPL_H
#define MBRICKELESTIFFBUILDERIMPL_H

#include <memory>
#include <org.sipesc.core.utility.progressmonitor.h>
#include <org.sipesc.core.engdbs.data.mdatamodel.h>
#include <org.sipesc.fems.hexaelement.mbrickelestiffbuilder.h>
using namespace org::sipesc::core::utility;
using namespace org::sipesc::core::engdbs::data;
using namespace org::sipesc::fems::hexaelement;

class MBrickEleStiffBuilderImpl: public MBrickEleStiffBuilderInterface
  {
  public:
    MBrickEleStiffBuilderImpl();

    virtual ~MBrickEleStiffBuilderImpl();

  public:
    void setStrainType(const QString& strainMatrix);
    /**
     * to set element constitutive type
     *
     */
    void setConstType(const QString& eleConst);
    /**
     * to set element integration type
     *
     */
    void setIntegType(const QString& integForm);
    /**
     * initialize Task object with given parent object, provider and receiver
     *
     * @param parentTask parent task
     * @param model object of MDataModel
     * @return if succeed, return true, otherwise return false
     */
    bool initialize(MDataModel& model, bool isRepeated);
    /**
     * 取进度监视对象
     */
    ProgressMonitor getProgressMonitor() const;
    /**
     * to create element stiffness calculation task object
     *
     */
    MExtension build(const QVariant& type);

  private:
    class Data;
    std::auto_ptr<Data> _data;
  };

#endif /* MBRICKELESTIFFBUILDERIMPL_H */
