#ifndef MBRICKELESTIFFCALCULATORIMPL_H
#define MBRICKELESTIFFCALCULATORIMPL_H

#include <memory>
#include <org.sipesc.core.utility.progressmonitor.h>
#include <org.sipesc.core.engdbs.data.mdatamodel.h>
#include <org.sipesc.utilities.mextensionfactorymanager.h>
#include <org.sipesc.fems.element.melementstrainmatrix.h>
#include <org.sipesc.fems.element.mintegform.h>
#include <org.sipesc.fems.hexaelement.mbrickelestiffcalculator.h>
using namespace org::sipesc::core::utility;
using namespace org::sipesc::core::engdbs::data;
using namespace org::sipesc::utilities;
using namespace org::sipesc::fems::element;
using namespace org::sipesc::fems::hexaelement;

class MBrickEleStiffCalculatorImpl: public MBrickEleStiffCalculatorInterface
  {
  public:
    MBrickEleStiffCalculatorImpl();

    virtual ~MBrickEleStiffCalculatorImpl();

  public:
    /**
     * initialize Task object
     */
    void setStrainMatrix(const MElementStrainMatrix& B);
    /**
     * initialize Task object
     */
    void setIntegForm(const MIntegForm& integ);
    /**
     * initialize Task object
     */
    void setEleConst(const MExtensionFactoryManager& eleConstiManager);
    /**
     * initialize Task object with given parent object, provider and receiver
     *
     * @param parentTask parent task
     * @param model object of MDataModel
     * @return if succeed, return true, otherwise return false
     */
    bool initialize(MDataModel& model, bool isRepeated);
    /**
     * 取进度监视对象
     */
    ProgressMonitor getProgressMonitor() const;
    /**
     * start one task with given dataobject and return result dataobject
     *
     * @param data on which current task will be performed
     * @return result dataobject
     */
    MDataObject start(const MDataObject& data);

  private:
    class Data;
    std::auto_ptr<Data> _data;
  };

#endif /* MBRICKELESTIFFCALCULATORIMPL_H */
