#ifndef MGAU3D2INTEGFORMFACTORYIMPL_H_
#define MGAU3D2INTEGFORMFACTORYIMPL_H_

#include <mobjectmanager.h>
#include <mgau3d2integformimpl.h>
#include <org.sipesc.fems.global.melementsglobal.h>
#include <org.sipesc.fems.hexaelement.mgau3d2integformfactory.h>
using namespace org::sipesc::fems::global;
using namespace org::sipesc::fems::hexaelement;

class MGau3D2IntegFormFactoryImpl: public MGau3D2IntegFormFactoryInterface
  {
  public:
    /**
     * 析构函数. 仅为类继承关系而设置.
     */
    virtual ~MGau3D2IntegFormFactoryImpl()
      {
      }

  public:
    QList<QVariant> getTypes() const
      {
      MObjectManager objManager = MObjectManager::getManager();
      MElementsGlobal global = objManager.getObject(
          "org.sipesc.fems.global.elementsglobal");
      QList<QVariant> list;
      list << global.getValue(MElementsGlobal::Gau3D2IntegForm)
          << global.getValue(MElementsGlobal::HexaBrickElement);
      return list;
      }

    QString getDescription() const
      {
      return "factory for MGau3D2IntegForm";
      }

    QString getIcon() const
      {
      return QString();
      }
    /*
     * 返回优先级
     */
    uint getPriority(const QVariant& key) const
      {
      return 10;
      }
    /**
     * create task object
     *
     * @return return a valid MExtensionWrapper object
     */
    MExtension createExtension(const QVariant& key) const
      {
      MGau3D2IntegFormImpl* p = new MGau3D2IntegFormImpl;
      return MGau3D2IntegForm(p);
      }
  };

#endif /* MGAU3D2INTEGFORMFACTORYIMPL_H_ */
