#ifndef MGAU3D2INTEGFORMIMPL_H_
#define MGAU3D2INTEGFORMIMPL_H_

#include <memory>
#include <org.sipesc.fems.femsutils.mintegpoint.h>
#include <org.sipesc.fems.hexaelement.mgau3d2integform.h>
using namespace org::sipesc::fems::femsutils;
using namespace org::sipesc::fems::hexaelement;

class MGau3D2IntegFormImpl: public MGau3D2IntegFormInterface
  {
  public:
    MGau3D2IntegFormImpl();
    /**
     * 析构函数. 仅为类继承关系而设置.
     */
    virtual ~MGau3D2IntegFormImpl();
    /**
     * to get integral point count
     *
     * @return integral point count
     */
    int getCount() const;
    /**
     * to get coordinate and weight value for integral point
     *
     * @param index integral point index
     * @return integral point data object
     */
    MIntegPoint getIntegPoint(const int& index) const;

  private:
    class Data;
    std::auto_ptr<Data> _data;
  };

#endif /* MGAU3D2INTEGFORMIMPL_H_ */
