/*
 * mgau3dintegformimpl.h
 *
 *  Created on: 2014年11月20日
 *      Author: steven
 */

#ifndef MGAU3DINTEGFORMIMPL_H_
#define MGAU3DINTEGFORMIMPL_H_

#include <memory>
#include <org.sipesc.fems.femsutils.mintegpoint.h>
#include <org.sipesc.fems.hexaelement.mgau3dintegform.h>
using namespace org::sipesc::fems::femsutils;
using namespace org::sipesc::fems::hexaelement;

class MGau3DIntegFormImpl: public MGau3DIntegFormInterface
  {
  public:
    MGau3DIntegFormImpl();
    /**
     * 析构函数. 仅为类继承关系而设置.
     */
    virtual ~MGau3DIntegFormImpl();
    /**
     * to get integral point count
     *
     * @return integral point count
     */
    int getCount() const;
    /**
     * to get coordinate and weight value for integral point
     *
     * @param index integral point index
     * @return integral point data object
     */
    MIntegPoint getIntegPoint(const int& index = 0) const;

  private:
    class Data;
    std::auto_ptr<Data> _data;
  };

#endif /* MGAU3DINTEGFORMIMPL_H_ */
