#ifndef MGHEXABRICKNODESTRESSCALCULATORFACTORYIMPL_H
#define MGHEXABRICKNODESTRESSCALCULATORFACTORYIMPL_H


#include <mobjectmanager.h>
#include <mghexabricknodestresscalculatorimpl.h>
#include <org.sipesc.fems.global.melementsglobal.h>
#include <org.sipesc.fems.hexaelement.mghexabricknodestresscalculatorfactory.h>
using namespace org::sipesc::fems::global;
using namespace org::sipesc::fems::hexaelement;

class MGHexaBrickNodeStressCalculatorFactoryImpl: public MGHexaBrickNodeStressCalculatorFactoryInterface
  {
  public:
    /**
     * 析构函数. 仅为类继承关系而设置.
     */
    virtual ~MGHexaBrickNodeStressCalculatorFactoryImpl()
      {
      }

  public:
    QList<QVariant> getTypes() const
      {
      MObjectManager objManager = MObjectManager::getManager();
      MElementsGlobal global = objManager.getObject(
          "org.sipesc.fems.global.elementsglobal");
      QList < QVariant > list;
      list << global.getValue(MElementsGlobal::HexaBrickElement);
      return list;
      }

    QString getDescription() const
      {
      return "factory for MGHexaBrickNodeStressCalculator";
      }

    QString getIcon() const
      {
      return QString();
      }
    /*
     * 返回优先级
     */
    uint getPriority(const QVariant& key) const
      {
      return 10;
      }
    /**
     * create task object
     *
     * @return return a valid MExtensionWrapper object
     */
    MExtension createExtension(const QVariant& key) const
      {
      MGHexaBrickNodeStressCalculatorImpl* p =
          new MGHexaBrickNodeStressCalculatorImpl;
      return MGHexaBrickNodeStressCalculator(p);
      }
  };

#endif /* MGHEXABRICKNODESTRESSCALCULATORFACTORYIMPL_H */
