#ifndef MHEXABRICKELEMASSCALCULATORFACTORYIMPL_H_
#define MHEXABRICKELEMASSCALCULATORFACTORYIMPL_H_

#include <mobjectmanager.h>
#include <org.sipesc.fems.global.melementsglobal.h>
#include <org.sipesc.fems.mass.melementmassbuilder.h>
#include <org.sipesc.fems.hexaelement.mhexabrickelemasscalculatorfactory.h>
using namespace org::sipesc::fems::global;
using namespace org::sipesc::fems::mass;
using namespace org::sipesc::fems::hexaelement;

class MHexaBrickEleMassCalculatorFactoryImpl: public MHexaBrickEleMassCalculatorFactoryInterface
  {
  public:
    /**
     * 析构函数. 仅为类继承关系而设置.
     */
    virtual ~MHexaBrickEleMassCalculatorFactoryImpl()
      {
      }

  public:
    QList<QVariant> getTypes() const
      {
      MObjectManager objManager = MObjectManager::getManager();
      MElementsGlobal global = objManager.getObject(
          "org.sipesc.fems.global.elementsglobal");
      QList < QVariant > list;
      list << global.getValue(MElementsGlobal::HexaBrickElement)
          << "Hexa185BrickElement";
      return list;
      }

    QString getDescription() const
      {
      return "factory for MHexaBrickEleMassCalculator";
      }

    QString getIcon() const
      {
      return QString();
      }
    /*
     * 返回优先级
     */
    uint getPriority(const QVariant& key) const
      {
      return 10;
      }
    /**
     * create task object
     *
     * @return return a valid MExtensionWrapper object
     */
    MExtension createExtension(const QVariant& key) const
      {
      MExtensionManager extManager = MExtensionManager::getManager();
      MElementMassBuilder eleMassBuilder = extManager.createExtension(
          "org.sipesc.fems.mass.MElementMassBuilder");
      Q_ASSERT(!eleMassBuilder.isNull());
      eleMassBuilder.setMassType("hexabrickmass");

      return eleMassBuilder;
      }
  };

#endif /* MHEXABRICKELEMASSCALCULATORFACTORYIMPL_H_ */
