#ifndef MHEXABRICKELESTIFFCALCULATORFACTORYIMPL_H_
#define MHEXABRICKELESTIFFCALCULATORFACTORYIMPL_H_

#include <mextensionmanager.h>
#include <mobjectmanager.h>
#include <org.sipesc.fems.global.melementsglobal.h>


//#include <org.sipesc.fems.element.melementstiffbuilder.h>
#include <org.sipesc.fems.hexaelement.mbrickelestiffbuilder.h>


#include <org.sipesc.fems.hexaelement.mhexabrickelestiffcalculatorfactory.h>
using namespace org::sipesc::fems::global;

//using namespace org::sipesc::fems::element;
using namespace org::sipesc::fems::hexaelement;

class MHexaBrickEleStiffCalculatorFactoryImpl: public MHexaBrickEleStiffCalculatorFactoryInterface
  {
  public:
    MHexaBrickEleStiffCalculatorFactoryImpl()
      {
      MObjectManager objManager = MObjectManager::getManager();
      _global = objManager.getObject(
          "org.sipesc.fems.global.elementsglobal");
      }
    /*
     * 析构函数，仅为类继承关系而设置。
     */
    virtual ~MHexaBrickEleStiffCalculatorFactoryImpl()
      {
      }

  public:
    QList<QVariant> getTypes() const
      {
      QList<QVariant> list;
      list << _global.getValue(MElementsGlobal::HexaBrickElement);
      return list;
      }

    QString getDescription() const
      {
      return "factory for MHexaBrickEleStiffCalculator";
      }

    QString getIcon() const
      {
      return QString();
      }
    /*
     * 返回优先级
     */
    uint getPriority(const QVariant& key) const
      {
      return 10;
      }
    /*
     * create task object
     *
     * @ return a valid MExtensionWrapper object
     */
    MExtension createExtension(const QVariant& key) const
      {
      MExtensionManager extManager = MExtensionManager::getManager();


//      MElementStiffBuilder eleStiffBuilder = extManager.createExtension(
//          "org.sipesc.fems.element.MElementStiffBuilder");
      MBrickEleStiffBuilder eleStiffBuilder = extManager.createExtension(
          "org.sipesc.fems.hexaelement.MBrickEleStiffBuilder");


      Q_ASSERT(!eleStiffBuilder.isNull());
      eleStiffBuilder.setStrainType(
          _global.getValue(MElementsGlobal::HexaBrickStrainMatrix));
      eleStiffBuilder.setConstType("brickeleconstidparser");
      eleStiffBuilder.setIntegType(
          _global.getValue(MElementsGlobal::Gau3D2IntegForm));

      return eleStiffBuilder;
      }

  private:
    MElementsGlobal _global;
  };

#endif /* MHEXABRICKELESTIFFCALCULATORFACTORYIMPL_H_ */
