#ifndef MHEXABRICKELESTRESSCALCULATORFACTORYIMPL_H_
#define MHEXABRICKELESTRESSCALCULATORFACTORYIMPL_H_

#include <mextensionmanager.h>
#include <mobjectmanager.h>
#include <org.sipesc.fems.global.melementsglobal.h>
#include <org.sipesc.fems.stress.melementstressbuilder.h>
#include <org.sipesc.fems.hexaelement.mhexabrickelestresscalculatorfactory.h>
using namespace org::sipesc::fems::global;
using namespace org::sipesc::fems::stress;
using namespace org::sipesc::fems::hexaelement;

class MHexaBrickEleStressCalculatorFactoryImpl: public MHexaBrickEleStressCalculatorFactoryInterface
  {
  public:
    MHexaBrickEleStressCalculatorFactoryImpl()
      {
      MObjectManager objManager = MObjectManager::getManager();
      _global = objManager.getObject(
          "org.sipesc.fems.global.elementsglobal");
      }
    /**
     * 析构函数. 仅为类继承关系而设置.
     */
    virtual ~MHexaBrickEleStressCalculatorFactoryImpl()
      {
      }

  public:
    QList<QVariant> getTypes() const
      {
      QList < QVariant > list;
      list << _global.getValue(MElementsGlobal::HexaBrickElement)
          << "Hexa185BrickElement";
      return list;
      }

    QString getDescription() const
      {
      return "factory for MHexaBrickEleStressCalculator";
      }

    QString getIcon() const
      {
      return QString();
      }

    /*
     * 返回优先级
     */
    uint getPriority(const QVariant& key) const
      {
      return 10;
      }

    /**
     * create task object
     *
     * @return return a valid MExtensionWrapper object
     */
    MExtension createExtension(const QVariant& key) const
      {
      MExtensionManager extManager = MExtensionManager::getManager();
      MElementStressBuilder eleStressBuilder = extManager.createExtension(
          "org.sipesc.fems.stress.MElementStressBuilder");
      Q_ASSERT(!eleStressBuilder.isNull());

      eleStressBuilder.setConstiType("brickmatdparser");
      eleStressBuilder.setIntegType(
          _global.getValue(MElementsGlobal::Gau3D2IntegForm));

      return eleStressBuilder;
      }

  private:
    MElementsGlobal _global;
  };

#endif /* MHEXABRICKELESTRESSCALCULATORFACTORYIMPL_H_ */
