#ifndef MHEXABRICKNODESTRESSCALCULATORIMPL_H_
#define MHEXABRICKNODESTRESSCALCULATORIMPL_H_

#include <memory>
#include <org.sipesc.core.engdbs.data.mdataobject.h>
#include <org.sipesc.fems.hexaelement.mhexabricknodestresscalculator.h>
using namespace org::sipesc::core::engdbs::data;
using namespace org::sipesc::fems::hexaelement;

class MHexaBrickNodeStressCalculatorImpl: public MHexaBrickNodeStressCalculatorInterface
  {
  public:
    MHexaBrickNodeStressCalculatorImpl();
    /**
     * 析构函数. 仅为类继承关系而设置.
     */
    virtual ~MHexaBrickNodeStressCalculatorImpl();
    /**
     * to set element node coordinate
     *
     * @param eleData data which stores element node information
     */
    void setState(const MDataObject& localData);
    /**
     * to get strain matrix
     *
     * @param integ data which stores parameter coordinate of integral point
     * @return strain matrix
     */
    MDataObject getNodeStress(const MDataObject& integStressData);

  private:
    class Data;
    std::auto_ptr<Data> _data;
  };

#endif /* MHEXABRICKNODESTRESSCALCULATORIMPL_H_ */
