#ifndef MHEXASHPFUNCTIONFACTORYIMPL_H_
#define MHEXASHPFUNCTIONFACTORYIMPL_H_

#include <mobjectmanager.h>
#include <mhexashpfunctionimpl.h>
#include <org.sipesc.fems.global.melementsglobal.h>
#include <org.sipesc.fems.hexaelement.mhexashpfunctionfactory.h>
using namespace org::sipesc::fems::global;
using namespace org::sipesc::fems::hexaelement;

class MHexaShpFunctionFactoryImpl: public MHexaShpFunctionFactoryInterface
  {
  public:
    /*
     * 析构函数，仅为类继承关系而设置。
     */
    virtual ~MHexaShpFunctionFactoryImpl()
      {
      }

  public:
    QList<QVariant> getTypes() const
      {
      MObjectManager objManager = MObjectManager::getManager();
      MElementsGlobal global = objManager.getObject(
          "org.sipesc.fems.global.elementsglobal");
      QList<QVariant> list;
      list << global.getValue(MElementsGlobal::HexaShpFunction);
      return list;
      }

    QString getDescription() const
      {
      return "factory for MHexaShpFunction";
      }

    QString getIcon() const
      {
      return QString();
      }
    /*
     * 返回优先级
     */
    uint getPriority(const QVariant& key) const
      {
      return 10;
      }
    /*
     * create task object
     *
     * @return  return a valid MExtensionWrapper object
     */
    MExtension createExtension(const QVariant& key) const
      {
      MHexaShpFunctionImpl* p = new MHexaShpFunctionImpl;
      return MHexaShpFunction(p);
      }
  };

#endif /* MHEXASHPFUNCTIONFACTORYIMPL_H_ */
