#ifndef MHEXASHPFUNCTIONIMPL_H_
#define MHEXASHPFUNCTIONIMPL_H_

#include <org.sipesc.fems.matrix.mmatrixfactory.h>
#include <org.sipesc.fems.data.mnodedata.h>
#include <org.sipesc.fems.hexaelement.mhexashpfunction.h>
using namespace org::sipesc::fems::matrix;
using namespace org::sipesc::fems::data;
using namespace org::sipesc::fems::hexaelement;

class MHexaShpFunctionImpl: public MHexaShpFunctionInterface
  {
  public:
    MHexaShpFunctionImpl();
    /**
     * 析构函数，仅为类继承关系而设置。
     */
    ~MHexaShpFunctionImpl();
    /*
     * to get shape function
     *
     * @param paraCoord data which stores parameter coordinate of integral point
     * @ return shape function matrix
     */
    MMatrix getShpFunction(const QList<double>& paraCoord,
        const QVector<MNodeData>& nodeLocalCoord = QVector<MNodeData>()) const;
    /*
     * to get shape function derivative matrix
     *
     * @param paraCoord data which stores parameter coordinate of integral point
     * @return shape function derivative matrix
     */
    MMatrix getShpFuncDerivative(const QList<double>& paraCoord,
        const QVector<MNodeData>& nodeLocalCoord = QVector<MNodeData>()) const;

  private:
    MMatrixFactory _mFactory;
  };

#endif /* MHEXASHPFUNCTIONIMPL_H_ */
