#ifndef ORG_SIPESC_FEMS_EXAMPLE_H
#define ORG_SIPESC_FEMS_EXAMPLE_H

#include <mplugin.h>

class OrgSipescFemsExamplePlugin:public MPluginObject
  {
  public:
    OrgSipescFemsExamplePlugin();
    virtual ~OrgSipescFemsExamplePlugin();
  public:
    bool initialize();
    bool cleanup();
    void start();
    void stop();
    void setupMetaTypes();
  public:
    QByteArray getPluginXml() const;
    QStringList getRequiredFeatures() const;
    QString getTextStringForId(qint32) const;
    QVariant getData(const QString& text) const;
    int convertData(QVariant&, const QString& type) const;
  protected:
    QVariant callMethod(MExtensionObject*, const QString&, const QString&, QList<void*>&);
    MExtensionObject* createObject(const QString&);
    MExtensionObject* createOrgSipescFemsHexaelementMCHEXAHandler();
    MExtensionObject* createOrgSipescFemsHexaelementMBrickEleConstiDParser();
    MExtensionObject* createOrgSipescFemsHexaelementMHexaBrickStrainMatrix();
    MExtensionObject* createOrgSipescFemsHexaelementMHexaShpFunction();
    MExtensionObject* createOrgSipescFemsHexaelementMGau3D2IntegForm();
    MExtensionObject* createOrgSipescFemsHexaelementMGau3D2IntegFormFactory();
    MExtensionObject* createOrgSipescFemsHexaelementMGau3DIntegForm();
    MExtensionObject* createOrgSipescFemsHexaelementMGau3DIntegFormFactory();
    MExtensionObject* createOrgSipescFemsHexaelementMHexaBrickNodeStressCalculator();
    MExtensionObject* createOrgSipescFemsHexaelementMHexaBrickLumpedMassMatrix();
    MExtensionObject* createOrgSipescFemsHexaelementMHexaBrickEleVolume();
    MExtensionObject* createOrgSipescFemsHexaelementMUnvHexaBrickEleDataExportor();
    MExtensionObject* createOrgSipescFemsHexaelementMCHEXAHandlerFactory();
    MExtensionObject* createOrgSipescFemsHexaelementMHexaBrickEleStiffCalculatorFactory();
    MExtensionObject* createOrgSipescFemsHexaelementMBrickEleConstiDParserFactory();
    MExtensionObject* createOrgSipescFemsHexaelementMHexaBrickStrainMatrixFactory();
    MExtensionObject* createOrgSipescFemsHexaelementMHexaShpFunctionFactory();

    MExtensionObject* createOrgSipescFemsHexaelementMHexaBrickEleStrainCalculatorFactory();
    MExtensionObject* createOrgSipescFemsHexaelementMHexaBrickEleStressCalculatorFactory();
    MExtensionObject* createOrgSipescFemsHexaelementMHexaBrickNodeStressCalculatorFactory();
    MExtensionObject* createOrgSipescFemsHexaelementMHexaBrickEleMassCalculatorFactory();
    MExtensionObject* createOrgSipescFemsHexaelementMHexaBrickLumpedMassMatrixFactory();
    MExtensionObject* createOrgSipescFemsHexaelementMHexaBrickEleVolumeFactory();
    MExtensionObject* createOrgSipescFemsHexaelementMUnvHexaBrickEleDataExportorFactory();
    MExtensionObject* createOrgSipescFemsHexaelementMACHEXA185Handler();
    MExtensionObject* createOrgSipescFemsHexaelementMACHEXA185HandlerFactory();
    MExtensionObject* createOrgSipescFemsHexaelementMHexa185BrickEleStiffCalculatorFactory();
    MExtensionObject* createOrgSipescFemsHexaelementMHexa185BrickStrainMatrix();
    MExtensionObject* createOrgSipescFemsHexaelementMHexa185BrickStrainMatrixFactory();
    MExtensionObject* createOrgSipescFemsHexaelementMHexa185BrickEleStrainCalculatorFactory();

    MExtensionObject* createOrgSipescFemsHexaelementMCHEXA20BDFHandler();
    MExtensionObject* createOrgSipescFemsHexaelementMCHEXA20BDFHandlerFactory();
    MExtensionObject* createOrgSipescFemsHexaelementMHexa20BrickStrainMatrix();
    MExtensionObject* createOrgSipescFemsHexaelementMHexa20ShpFunction();
    MExtensionObject* createOrgSipescFemsHexaelementMHexa20BrickStrainMatrixFactory();
    MExtensionObject* createOrgSipescFemsHexaelementMHexa20ShpFunctionFactory();
    MExtensionObject* createOrgSipescFemsHexaelementMGau3D3IntegForm();
    MExtensionObject* createOrgSipescFemsHexaelementMGau3D3IntegFormFactory();
    MExtensionObject* createOrgSipescFemsHexaelementM20BrickEleConstiDParser();
    MExtensionObject* createOrgSipescFemsHexaelementMHexa20BrickEleStiffCalculatorFactory();
    MExtensionObject* createOrgSipescFemsHexaelementM20BrickEleConstiDParserFactory();
    MExtensionObject* createOrgSipescFemsHexaelementMHexa20BrickNodeStressCalculator();
    MExtensionObject* createOrgSipescFemsHexaelementMHexa20BrickLumpedMassMatrix();
    MExtensionObject* createOrgSipescFemsHexaelementMHexa20BrickEleVolume();
    MExtensionObject* createOrgSipescFemsHexaelementMUnvHexa20BrickEleDataExportor();
    MExtensionObject* createOrgSipescFemsHexaelementMHexa20BrickEleStrainCalculatorFactory();
    MExtensionObject* createOrgSipescFemsHexaelementMHexa20BrickEleStressCalculatorFactory();
    MExtensionObject* createOrgSipescFemsHexaelementMHexa20BrickNodeStressCalculatorFactory();
    MExtensionObject* createOrgSipescFemsHexaelementMHexa20BrickEleMassCalculatorFactory();
    MExtensionObject* createOrgSipescFemsHexaelementMHexa20BrickLumpedMassMatrixFactory();
    MExtensionObject* createOrgSipescFemsHexaelementMHexa20BrickEleVolumeFactory();
    MExtensionObject* createOrgSipescFemsHexaelementMUnvHexa20BrickEleDataExportorFactory();
    MExtensionObject* createOrgSipescFemsHexaelementMCHEXA20CDBHandler();
    MExtensionObject* createOrgSipescFemsHexaelementMCHEXA20CDBHandlerFactory();

    MExtensionObject* createOrgSipescFemsHexaelementMGHexaBrickNodeStressCalculator();
    MExtensionObject* createOrgSipescFemsHexaelementMGHexaBrickNodeStressCalculatorFactory();
    MExtensionObject* createOrgSipescFemsHexaelementMBrickEleStiffBuilder();

  private:
    bool _running;
  };

#endif /* ORG_SIPESC_FEMS_EXAMPLE_H */
