#include <mgau3d2integformimpl.h>
#include <math.h>
#include <mextensionmanager.h>

class MGau3D2IntegFormImpl::Data
  {
  public:
    Data()
      {
      }

    QList<MIntegPoint> _integ;

  public:
    bool initialize()
      {
      //通过插件找工厂管理器
      MExtensionManager extManager = MExtensionManager::getManager();
      //生成自由度数据类解析器

      QList<double> weights, integCoord;

      weights.append(1.0);
      integCoord.append(0.577350269189626);
      weights.append(1.0);
      integCoord.append(-0.577350269189626);

      for (int i = 0; i < 2; i++)
        for (int j = 0; j < 2; j++)
          for (int k = 0; k < 2; k++)
            {
            MIntegPoint integPoint = extManager.createExtension(
                "org.sipesc.fems.femsutils.MIntegPoint");
            Q_ASSERT(!integPoint.isNull());
            integPoint.setWeight(
                weights.value(i) * weights.value(j) * weights.value(k));
            QList<double> paraCoord;
            paraCoord.append(integCoord.value(k));
            paraCoord.append(integCoord.value(j));
            paraCoord.append(integCoord.value(i));
            integPoint.setIntegCoord(paraCoord);
            int index = i * 4 + j * 2 + k;
            integPoint.setIndex(index);
            _integ.append(integPoint);
            }
      /*   _data->_dops = dop;
       enum
       {
       oneOrder = 1,
       twoOrder = 2,
       threeOrder = 3,
       fourOrder = 4,
       fiveOrder = 5,
       sixOrder = 6,
       };
       switch ( dop )
       {
       case oneOrder:
       _data->_weights.append(2.0);
       _data->_integralCoord.append(0.0);
       break;
       case twoOrder:
       _data->_weights.append(1.0);
       _data->_integralCoord.append(0.577350269189626);
       _data->_weights.append(1.0);
       _data->_integralCoord.append(-0.577350269189626);
       break;
       case threeOrder:
       _data->_weights.append(5.0/9.0);
       _data->_integralCoord.append(0.774596669241483);
       _data->_weights.append(8.0/9.0);
       _data->_integralCoord.append(0.0);
       _data->_weights.append(5.0/9.0);
       _data->_integralCoord.append(-0.774596669241483);
       break;
       case fourOrder:
       _data->_weights.append(0.347854845137454);
       _data->_integralCoord.append(0.861136311594053);
       _data->_weights.append(0.652145154862546);
       _data->_integralCoord.append(0.339981043584856);
       _data->_weights.append(0.652145154862546);
       _data->_integralCoord.append(-0.339981043584856);
       _data->_weights.append(0.347854845137454);
       _data->_integralCoord.append(-0.861136311594053);
       break;
       case fiveOrder:
       _data->_weights.append(0.236926885056189);
       _data->_integralCoord.append(0.906179845938664);
       _data->_weights.append(0.478628670499366);
       _data->_integralCoord.append(0.538469310105683);
       _data->_weights.append(0.568888888888889);
       _data->_integralCoord.append(0.0);
       _data->_weights.append(0.478628670499366);
       _data->_integralCoord.append(-0.538469310105683);
       _data->_weights.append(0.236926885056189);
       _data->_integralCoord.append(-0.906179845938664);
       break;
       case sixOrder:
       _data->_weights.append(0.171324492379170);
       _data->_integralCoord.append(0.932469514203152);
       _data->_weights.append(0.360761573048139);
       _data->_integralCoord.append(0.661209386466265);
       _data->_weights.append(0.467913934572691);
       _data->_integralCoord.append(0.238619186083197);
       _data->_weights.append(0.467913934572691);
       _data->_integralCoord.append(-0.238619186083197);
       _data->_weights.append(0.360761573048139);
       _data->_integralCoord.append(-0.932469514203152);
       _data->_weights.append(0.171324492379170);
       _data->_integralCoord.append(-0.932469514203152);
       break;
       default:
       return false;
       }*/
      return true;
      }
  };

MGau3D2IntegFormImpl::MGau3D2IntegFormImpl()
  {
  _data.reset(new MGau3D2IntegFormImpl::Data);

  if (!_data.get())
    mReportError(M_ERROR_FATAL, "MGau3D2IntegFormImpl::"
        "MGau3D2IntegFormImpl() ****** failed");

  if (!_data->initialize())
    mReportError(M_ERROR_FATAL, "MGau3D2IntegFormImpl::"
        "MGau3D2IntegFormImpl() ****** initialize failed");
  }

MGau3D2IntegFormImpl::~MGau3D2IntegFormImpl()
  {
  }

int MGau3D2IntegFormImpl::getCount() const
  {
  return 8;
  }

MIntegPoint MGau3D2IntegFormImpl::getIntegPoint(const int& index) const
  {
  return _data->_integ.value(index);
  }
/*QList<double> MGau3DIntegFormImpl::getWeights() const
 {
 Q_ASSERT(_data->_isInitialized);

 QList<double> _weightValue;
 int dop = _data->_dops;

 for(int i = 0; i < dop; i++)
 for(int j = 0; j < dop; j++)
 for(int k = 0; k < dop; k++)
 {
 _weightValue.append(_data->_weights.value(i) *
 _data->_weights.value(j) * _data->_weights.value(k));
 }

 return _weightValue;
 }

 QList<double> MGau3DIntegFormImpl::getIntegCoord(const int& index) const
 {
 Q_ASSERT(_data->_isInitialized);

 QList<double> _paraCoord;

 _paraCoord.append(_data->_integralCoord.value((index - 1)/
 _data->_dops/_data->_dops));
 _paraCoord.append( _data->_integralCoord.value((index - 1)/
 _data->_dops%_data->_dops));
 _paraCoord.append( _data->_integralCoord.value((index - 1)%_data->_dops));

 return _paraCoord;

 }*/

