/*
 * mgau3dintegformimpl.cxx
 *
 *  Created on: 2014年11月20日
 *      Author: steven
 */

#include <mgau3dintegformimpl.h>
#include <math.h>
#include <mextensionmanager.h>

class MGau3DIntegFormImpl::Data
  {
  public:
    Data()
      {
      }

    MIntegPoint _integ;

  public:
    bool initialize()
      {
      //通过插件找工厂管理器
      MExtensionManager extManager = MExtensionManager::getManager();
      //生成自由度数据类解析器
      _integ = extManager.createExtension(
          "org.sipesc.fems.femsutils.MIntegPoint");
      Q_ASSERT(!_integ.isNull());

      _integ.setWeight(2.0 * 2.0 * 2.0);

      QList<double> _paraCoord;
      _paraCoord.append(0.0);
      _paraCoord.append(0.0);
      _paraCoord.append(0.0);
      _integ.setIntegCoord(_paraCoord);
      _integ.setIndex(0);
      /*   _data->_dops = dop;
       enum
       {
       oneOrder = 1,
       twoOrder = 2,
       threeOrder = 3,
       fourOrder = 4,
       fiveOrder = 5,
       sixOrder = 6,
       };
       switch ( dop )
       {
       case oneOrder:
       _data->_weights.append(2.0);
       _data->_integralCoord.append(0.0);
       break;
       case twoOrder:
       _data->_weights.append(1.0);
       _data->_integralCoord.append(0.577350269189626);
       _data->_weights.append(1.0);
       _data->_integralCoord.append(-0.577350269189626);
       break;
       case threeOrder:
       _data->_weights.append(5.0/9.0);
       _data->_integralCoord.append(0.774596669241483);
       _data->_weights.append(8.0/9.0);
       _data->_integralCoord.append(0.0);
       _data->_weights.append(5.0/9.0);
       _data->_integralCoord.append(-0.774596669241483);
       break;
       case fourOrder:
       _data->_weights.append(0.347854845137454);
       _data->_integralCoord.append(0.861136311594053);
       _data->_weights.append(0.652145154862546);
       _data->_integralCoord.append(0.339981043584856);
       _data->_weights.append(0.652145154862546);
       _data->_integralCoord.append(-0.339981043584856);
       _data->_weights.append(0.347854845137454);
       _data->_integralCoord.append(-0.861136311594053);
       break;
       case fiveOrder:
       _data->_weights.append(0.236926885056189);
       _data->_integralCoord.append(0.906179845938664);
       _data->_weights.append(0.478628670499366);
       _data->_integralCoord.append(0.538469310105683);
       _data->_weights.append(0.568888888888889);
       _data->_integralCoord.append(0.0);
       _data->_weights.append(0.478628670499366);
       _data->_integralCoord.append(-0.538469310105683);
       _data->_weights.append(0.236926885056189);
       _data->_integralCoord.append(-0.906179845938664);
       break;
       case sixOrder:
       _data->_weights.append(0.171324492379170);
       _data->_integralCoord.append(0.932469514203152);
       _data->_weights.append(0.360761573048139);
       _data->_integralCoord.append(0.661209386466265);
       _data->_weights.append(0.467913934572691);
       _data->_integralCoord.append(0.238619186083197);
       _data->_weights.append(0.467913934572691);
       _data->_integralCoord.append(-0.238619186083197);
       _data->_weights.append(0.360761573048139);
       _data->_integralCoord.append(-0.932469514203152);
       _data->_weights.append(0.171324492379170);
       _data->_integralCoord.append(-0.932469514203152);
       break;
       default:
       return false;
       }*/
      return true;
      }
  };

MGau3DIntegFormImpl::MGau3DIntegFormImpl()
  {
  _data.reset(new MGau3DIntegFormImpl::Data);

  if (!_data.get())
    mReportError(M_ERROR_FATAL, "MGau3DIntegFormImpl::"
        "MGau3DIntegFormImpl() ****** failed");

  if (!_data->initialize())
    mReportError(M_ERROR_FATAL, "MGau3DIntegFormImpl::"
        "MGau3DIntegFormImpl() ****** initialize failed");
  }

MGau3DIntegFormImpl::~MGau3DIntegFormImpl()
  {
  }

int MGau3DIntegFormImpl::getCount() const
  {
  return 1;
  }

MIntegPoint MGau3DIntegFormImpl::getIntegPoint(const int& index) const
  {
  return _data->_integ;
  }
/*QList<double> MGau3DIntegFormImpl::getWeights() const
 {
 Q_ASSERT(_data->_isInitialized);

 QList<double> _weightValue;
 int dop = _data->_dops;

 for(int i = 0; i < dop; i++)
 for(int j = 0; j < dop; j++)
 for(int k = 0; k < dop; k++)
 {
 _weightValue.append(_data->_weights.value(i) *
 _data->_weights.value(j) * _data->_weights.value(k));
 }

 return _weightValue;
 }

 QList<double> MGau3DIntegFormImpl::getIntegCoord(const int& index) const
 {
 Q_ASSERT(_data->_isInitialized);

 QList<double> _paraCoord;

 _paraCoord.append(_data->_integralCoord.value((index - 1)/
 _data->_dops/_data->_dops));
 _paraCoord.append( _data->_integralCoord.value((index - 1)/
 _data->_dops%_data->_dops));
 _paraCoord.append( _data->_integralCoord.value((index - 1)%_data->_dops));

 return _paraCoord;

 }*/
