#include <munvhexabrickeledataexportorimpl.h>
#include <qdebug.h>
#include <mobjectmanager.h>
#include <org.sipesc.core.utility.utilitymanager.h>
#include <org.sipesc.core.engdbs.data.mdatabasemanager.h>
#include <org.sipesc.fems.data.melementdata.h>
using namespace org::sipesc::fems::data;

class MUnvHexaBrickEleDataExportorImpl::Data
  {
  public:
    Data()
      {
      _isInitialized = false;
      }

  public:
    MDataModel _model;
    MDataManager _eleManager;
    MObjectManager _objManager;
    MDatabaseManager _baseManager;
    ProgressMonitor _monitor;
    bool _isInitialized;
  };

MUnvHexaBrickEleDataExportorImpl::MUnvHexaBrickEleDataExportorImpl()
  {
  _data.reset(new MUnvHexaBrickEleDataExportorImpl::Data);

  if (!_data.get())
    mReportError(M_ERROR_FATAL, "MUnvHexaBrickEleDataExportorImpl::"
        "MUnvHexaBrickEleDataExportorImpl() ****** failed");

  MObjectManager objManager = MObjectManager::getManager();
  UtilityManager util = objManager.getObject(
      "org.sipesc.core.utility.utilitymanager");
  Q_ASSERT(!util.isNull());
  _data->_monitor = util.createProgressMonitor(
      "MUnvHexaBrickEleDataExportor", ProgressMonitor());
  Q_ASSERT(!_data->_monitor.isNull());
  }

MUnvHexaBrickEleDataExportorImpl::~MUnvHexaBrickEleDataExportorImpl()
  {
  }

bool MUnvHexaBrickEleDataExportorImpl::initialize(MDataModel& model,
    bool isRepeated)
  {
  if (_data->_isInitialized)
    return false; //不能重复初始化

  _data->_model = model;

  _data->_baseManager = _data->_objManager.getObject(
      "org.sipesc.core.engdbs.mdatabasemanager");
  Q_ASSERT(!_data->_baseManager.isNull());

  _data->_isInitialized = true;
  return true;
  }

ProgressMonitor MUnvHexaBrickEleDataExportorImpl::getProgressMonitor() const
  {
  return _data->_monitor;
  }

bool MUnvHexaBrickEleDataExportorImpl::dataExport(QTextStream* stream,
    const QString& name)
  {
  if (_data->_eleManager.getName() != name) //因为每种载荷都在一起
    {
    _data->_eleManager = _data->_baseManager.createDataManager();
    bool ok = _data->_eleManager.open(_data->_model, name, true);
    if (!ok)
      {
      QString errorMessage = "can't open element  DataManager"
          " in MUnvHexaBrickEleDataExportorImpl::initialize() ";
      qDebug() << errorMessage;
      _data->_monitor.setMessage(errorMessage);
      return false;
      }
    }
//  eleManager.updateIndexOrder();
  int elementCount = _data->_eleManager.getDataCount();
  for (int i = 0; i < elementCount; i++)
    {
    MElementData elementData = _data->_eleManager.getDataAt(i);
    *stream << "(" << elementData.getId() << "," << "80600, 0, 0, 0, ";
    *stream << elementData.getNodeId(0) << ", ";
    *stream << elementData.getNodeId(1) << ", ";
    *stream << elementData.getNodeId(2) << ", ";
    *stream << elementData.getNodeId(3) << ", ";
    *stream << elementData.getNodeId(4) << ", ";
    *stream << elementData.getNodeId(5) << ", ";
    *stream << elementData.getNodeId(6) << ", ";
    *stream << elementData.getNodeId(7) << ";)" << "\n";
    }
  }
